<?php
class dxgraph
{
var 
$font_angle=0,
$font_size=20,
$font='',
$truecolor=true,
$image_width=0,
$image_height=0,
$image=NULL,
$r=255,
$g=255,
$b=255,
$tile=NULL,
$color=NULL,
$style=NULL,
$brush=NULL,
$thickness=1,
$point=NULL,
$point_x=0,
$point_y=0,
$point_width=0,
$point_height=0,
$isfilled=false,
$tiled=false,
$styled=false,
$brushed=false,
$lastcolors=array(),
$graph_xcenter=0,
$graph_ycenter=0,
$graph_bound=false,
$graph_xfrom=0,
$graph_yfrom=0,
$graph_xto=-1,
$graph_yto=-1,
$graph_xscale=1,
$graph_yscale=1,
$graph_precision=1,
$axis_xcenter=0,
$axis_ycenter=0,
$axis_backlength=-1,
$axis_frontlength=-1,
$axis_makesign=false,
$axis_signnum=1,
$axis_signstep=1,
$axis_signcolor=NULL,
$axis_signx=4,
$axis_signy=12,
$axis_symbols=array(),
$axis_backarrow=false,
$axis_frontarrow=true,
$axis_arrowx=12,
$axis_arrowy=3,
$axis_signfrom=0,
$net_stepx=20,
$net_stepy=20,
$diagram_x=0,
$diagram_y=0,
$diagram_width=17,
$diagram_step=3,
$diagram_max_height=150,
$diagram_signed=false,
$diagram_signcolor=NULL,
$diagram_index='',
$diagram_prefix='',
$diagram_txtx=5,
$diagram_txty=5,
$diagram_colors=array(),
$diagram_shadowx=0,
$diagram_shadowy=0,
$diagram_shadowtransparency=60,
$diagram_shadowcolors=array(),
$diagram_divider=1,
$diagram_round=5,
$hgraph_x=0,
$hgraph_y=0,
$hgraph_maxheight=150,
$hgraph_interval=20,
$hgraph_hidelines=false,
$hgraph_signed=false,
$hgraph_sx=0,
$hgraph_sy=0,
$hgraph_signcolor=NULL,
$hgraph_signs=array(),
$hgraph_fillcolor=NULL,
$hgraph_index='',
$hgraph_prefix='',
$hgraph_divider=1,
$hgraph_round=5,
$legend_x=0,
$legend_y=0,
$legend_texts=array(),
$legend_fields=5,
$legend_bordercolor=NULL,
$legend_borderwidth=2,
$dlegend_colorboxes=false,
$dlegend_boxbordercolor=NULL,
$dlegend_type=0,
$legend_fontcolor=NULL,
$legend_strinterval=2,
$legend_name='',
$legend_name_size=10,
$legend_name_fontcolor=NULL,
$legend_colortext=false,
$legend_fontname='',
$hlegends=array(),
$point_filename='',
$hlegend_linelen=10,
$point_filetype=0,
$cdiagram_max_radius=100,
$diagram_signes=array(),
$axis_rules1=false,
$axis_rules2=false,
$axis_linterval=5,
$axis_binterval=20,
$axis_little=3,
$axis_round=-1,
$axis_big=5,
$sgraph_values=array(),
$sgraph_maxheight=150,
$sgraph_x=0,
$sgraph_y=0,
$sgraph_backarrow=true,
$sgraph_frontarrow=false,
$sgraph_arrowx=12,
$sgraph_arrowy=3,
$sgraph_transparency=NULL,
$sgraph_r=-1,
$sgraph_g=-1,
$sgraph_b=-1;




function dxgraph($image_width=320,$image_height=240,$truecolor=true,$file='',$type=0,$copyresized=true,$createonlyfromfile=false)
{
  if($file)
  {
    switch($type)
    {
      default:
      case 0:
        $tmp=imagecreatefrompng($file);
        break;
      case 1:
        $tmp=imagecreatefromjpeg($file);
        break;
      case 2:
        $tmp=imagecreatefromgif($file);
        break;
    }

    if(!$tmp)
      return false;
  }

  if($createonlyfromfile && $file)
  {
    $this->image=$tmp;
    $this->image_width=imagesx($this->image);
    $this->image_height=imagesx($this->image);
    $this->truecolor=true;
    return true;
  }

  if(function_exists('imagecreatetruecolor') && $truecolor)
  {
    $this->image=imagecreatetruecolor($image_width,$image_height);
    $this->truecolor=true;
  }
  else
  {
    $this->image=imagecreate($image_width,$image_height);
    $this->truecolor=false;
  }

  $this->image_width=$image_width;
  $this->image_height=$image_height;

  $this->axis_ycenter=$this->image_width;
  $this->diagram_y=$this->image_height;
  $this->hgraph_y=$this->image_height;
  $this->legend_y=$this->image_height;

  $this->set_color();
  $this->image_fill();

  if(!$this->image)
    return false;

  if($file)
  {
    if($copyresized)
      $ret=imagecopyresized($this->image,$tmp,0,0,0,0,$this->image_width,$this->image_height,imagesx($tmp),imagesy($tmp));
    else
      $ret=imagecopy($this->image,$tmp,0,0,0,0,imagesx($tmp),imagesy($tmp));

    imagedestroy($tmp);
    return $ret;

  }
}



function image_resize($width=1,$height=1,$src_resize=false)
{
  if($this->truecolor)
    $tmp=imagecreatetruecolor($width,$height);
  else
    $tmp=imagecreate($width,$height);

  if(!$tmp)
    return false;

  if(!$src_resize)
  {
    if(!imagecopy($tmp,$this->image,0,0,0,0,$this->image_width,$this->image_height))
    {
      imagedestroy($tmp);
      return false;
    }
  }
  else
  {
    if(!imagecopyresized($tmp,$this->image,0,0,0,0,$width,$height,$this->image_width,$this->image_height))
    {
      imagedestroy($tmp);
      return false;
    }
  }

  imagedestroy($this->image);
  $this->image=$tmp;
  $this->image_width=$width;
  $this->image_height=$height;
  return true;
}



function image_rotate($angle=0)
{
  $tmp=imagerotate($this->image,$angle,$this->color);
  if(!$tmp)
    return false;

  imagedestroy($this->image);
  $this->image=$tmp;

  return true;
}



function get_image()
{
  return $this->image;
}



function get_tile()
{
  return $this->tile;
}



function get_brush()
{
  return $this->brush;
}



function get_point()
{
  return $this->point;
}



function get_image_params()
{
  return array(0 => $this->image_width, 1 => $this->image_height, 2 => $this->truecolor);
}



function get_current_params()
{
  return array(0 => $this->r, 1 => $this->g, 2 => $this->b, 3 => $this->thickness, 4 => $this->font, 5 => $this->font_size, 6 => $this->font_angle);
}



function set_font($font_size=20,$font_angle=0,$name='')
{
  if($name)
    $this->font=$name;

  $this->font_size=$font_size;
  $this->font_angle=$font_angle;
}



function set_line_thickness($lvl=1)
{
  if($this->thickness==$lvl)
    return true;

  $this->thickness=$lvl;
  return imagesetthickness($this->image,$lvl);
}



function set_image_tile($name,$type=0)
{
  if(!$name)
    return false;

  switch($type)
  {
  default:
  case 0:
    $this->tile=imagecreatefrompng($name);
    break;
  case 1:
    $this->tile=imagecreatefromjpeg($name);
    break;
  case 2:
    $this->tile=imagecreatefromgif($name);
    break;
  }

  if(!$this->tile)
    return false;

  return imagesettile($this->image,$this->tile);
}



function set_color($r=255,$g=255,$b=255,$transparency=false)
{
  $this->r=$r;
  $this->g=$g;
  $this->b=$b;

  if(!$transparency)
    $this->color=imagecolorallocate($this->image,$this->r,$this->g,$this->b);
  else
    $this->color=imagecolorallocatealpha($this->image,$this->r,$this->g,$this->b,$transparency);

  return $this->color;
}



function image_ttf_text($text,$x=0,$y=0,$unicode=false,$rotate_each=false,$letter_space=20,$color=NULL,$nsize=-1,$addfont='')
{
  if(!$this->font)
    return false;

  if($nsize>0)
    $size=$nsize;
  else
    $size=$this->font_size;

  if($color==NULL)
    $color=$this->color;

  if($addfont)
    $font=$addfont;
  else
    $font=$this->font;

  if(!$rotate_each)
  {
    if($unicode)
      $text=$this->to_unicode($text);

    return imagettftext($this->image,$size,$this->font_angle,$x,$y,$color,$font,$text);
  }
  else
  {
    for($i=0,$len=strlen($text);$i<$len;$i++)
    {
      $smb=substr($text,$i,1);

      if($unicode)
        $smb=$this->to_unicode($smb);

      if(!imagettftext($this->image,$size,$this->font_angle,$x+$i*$letter_space,$y,$color,$font,$smb))
        return false;
    }

    return true;
  }
}



function image_fill($rect_fill=false)
{
  if($this->tiled && $this->tile)
    $color=IMG_COLOR_TILED;
  else
    $color=$this->color;

  if($rect_fill)
    return $this->image_rectangle(0,0,$this->image_width,$this->image_height);
  else
    return imagefill($this->image,0,0,$color);
}



function image_output($format=0,$file=NULL)
{
  switch($format)
  {
    default:
    case 0:
      if(!$file)
      {
        header("Content-type: image/png");
        imagepng($this->image);
      }
      else
      {
        imagepng($this->image,$file);
      }

      break;
    case 1:
      if(!$file)
      {
        header("Content-type: image/jpeg");
        imagejpeg($this->image);
      }
      else
      {
        imagejpeg($this->image,$file);
      }

      break;
    case 2:
      if(!$file)
      {
        header("Content-type: image/gif");
        imagegif($this->image);
      }
      else
      {
        imagegif($this->image,$file);
      }

      break;
  }

}



function image_arc($xcenter=0,$ycenter=0,$width=0,$height=0,$angle_start=0,$angle_end=360,$fillstyle=IMG_ARC_PIE,$speccolor=NULL,$notfilled=false)
{
  if($this->tiled && $this->isfilled && $this->tile)
    $color=IMG_COLOR_TILED;
  else
    $color=$this->color;

  if($this->styled && $this->style)
    $color=IMG_COLOR_STYLED;

  if($this->brushed && $this->brush)
    $color=IMG_COLOR_BRUSHED;

  if($speccolor!=NULL)
    $color=$speccolor;

  if(!$this->isfilled ||$notfilled)
    return imagearc($this->image,$xcenter,$ycenter,$width,$height,$angle_start,$angle_end,$color);
  else
    return imagefilledarc($this->image,$xcenter,$ycenter,$width,$height,$angle_start,$angle_end,$color,$fillstyle);
}



function image_filled_ellipse($xcenter=0,$ycenter=0,$width=0,$height=0)
{
  if($this->tiled && $this->isfilled && $this->tile)
    $color=IMG_COLOR_TILED;
  else
    $color=$this->color;

  if($this->styled && $this->style)
    $color=IMG_COLOR_STYLED;

  if($this->brushed && $this->brush)
    $color=IMG_COLOR_BRUSHED;

  return imagefilledellipse($this->image,$xcenter,$ycenter,$width,$height,$color);
}



function image_circle($xcenter=0,$ycenter=0,$radius=0,$fillstyle=IMG_ARC_PIE,$speccolor=NULL,$notfilled=false)
{
  return $this->image_arc($xcenter,$ycenter,$radius,$radius,0,360,$fillstyle,$speccolor,$notfilled);
}



function image_line($x1,$y1,$x2,$y2,$scolor=NULL,$width=-1)
{
  if($this->styled && $this->style)
    $color=IMG_COLOR_STYLED;
  else
    $color=$this->color;

  if($this->brushed && $this->brush)
    $color=IMG_COLOR_BRUSHED;

  if($scolor)
    $color=$scolor;

  if($width>0)
  {
    $temp=$this->thickness;
    $this->set_line_thickness($width);
  }

  $xtmp=imageline($this->image,$x1,$y1,$x2,$y2,$color);

  if($width>0)
    $this->set_line_thickness($temp);

  return $xtmp;
}



function image_make_border()
{
  return $this->image_rectangle(0,0,$this->image_width-1,$this->image_height-1);
}



function image_rectangle($x1,$y1,$x2,$y2,$speccolor=NULL,$notfilled=false,$width=-1)
{
  if($this->tiled && $this->isfilled && $this->tile && !$notfilled)
    $color=IMG_COLOR_TILED;
  else
    $color=$this->color;

  if($this->styled && $this->style)
    $color=IMG_COLOR_STYLED;

  if($this->brushed && $this->brush)
    $color=IMG_COLOR_BRUSHED;

  if($speccolor!=NULL)
    $color=$speccolor;

  if($width>0)
  {
    $temp=$this->thickness;
    $this->set_line_thickness($width);
  }

  if(!$this->isfilled || $notfilled)
    $xtmp=imagerectangle($this->image,$x1,$y1,$x2,$y2,$color);
  else
    $xtmp=imagefilledrectangle($this->image,$x1,$y1,$x2,$y2,$color);

  if($width>0)
    $this->set_line_thickness($temp);

  return $xtmp;
}



function image_hatch($step=7,$angle=45)
{
  $angle=deg2rad($angle);
  $nx=$this->image_height/tan($angle);
  $ncx=abs(ceil($nx));
  $nbx=round($nx,0);

  for($i=-$this->image_width*$ncx;$i<=$this->image_width*$ncx;$i+=$step)
  {
    $this->image_line($i,$this->image_height,$i+$nbx,0);
  }
}


function net_set_steps($xstep=10,$ystep=10)
{
  $this->net_stepx=$xstep;
  $this->net_stepy=$ystep;
  $this->graph_xscale=$xstep;
  $this->graph_yscale=$ystep;
}


function image_net($xfrom=0,$yfrom=0,$xto=-1,$yto=-1)
{
  $xto=$xto<0 ? $this->image_width : $xto;
  $yto=$yto<0 ? $this->image_height : $yto;

  if($this->net_stepx)
  {
    for($i=$xfrom;$i<=$xto;$i+=$this->net_stepx)
    {
      $this->image_line($i,$yfrom,$i,$yto);
    }
  }

  if($this->net_stepy)
  {
    for($i=$yfrom;$i<=$yto;$i+=$this->net_stepy)
    {
      $this->image_line($xfrom,$i,$xto,$i);
    }
  }
}



function image_grad($type=0,$colors=array(),$xfrom=0,$yfrom=0,$xto=-1,$yto=-1,$transparency=NULL)
{
  $xto=$xto<0 ? $this->image_width : $xto;
  $yto=$yto<0 ? $this->image_height : $yto;

  $width=$xto-$xfrom;
  $height=$yto-$yfrom;

  if($type==0)
  {
    $rc=($colors[0]-$colors[1])/$width;
    $gc=($colors[2]-$colors[3])/$width;
    $bc=($colors[4]-$colors[5])/$width;

    for($i=$xfrom;$i<=$xto;$i++)
    {
      $this->image_line($i,$yfrom,$i,$yto,$this->rgb(round($colors[1]+$rc*($i-$xfrom)),round($colors[3]+$gc*($i-$xfrom)),round($colors[5]+$bc*($i-$xfrom)),$transparency));
    }
  }
  elseif($type==1)
  {
    $rc=($colors[0]-$colors[1])/$height;
    $gc=($colors[2]-$colors[3])/$height;
    $bc=($colors[4]-$colors[5])/$height;

    for($i=$yfrom;$i<=$yto;$i++)
    {
      $this->image_line($xfrom,$i,$xto,$i,$this->rgb(round($colors[1]+$rc*($i-$yfrom)),round($colors[3]+$gc*($i-$yfrom)),round($colors[5]+$bc*($i-$yfrom)),$transparency));
    }
  }
  elseif($type==2)
  {
    $this->image_grad(0,$colors,$xfrom,$yfrom,$xto/2,$yto,$transparency);
    $tmp=$colors[1];
    $colors[1]=$colors[0];
    $colors[0]=$tmp;
    $tmp=$colors[3];
    $colors[3]=$colors[2];
    $colors[2]=$tmp;
    $tmp=$colors[4];
    $colors[4]=$colors[5];
    $colors[5]=$tmp;
    $this->image_grad(0,$colors,$xto/2+1,$yfrom,$xto,$yto,$transparency);
  }
  elseif($type==3)
  {
    $this->image_grad(1,$colors,$xfrom,$yfrom,$xto,$yto/2,$transparency);
    $tmp=$colors[1];
    $colors[1]=$colors[0];
    $colors[0]=$tmp;
    $tmp=$colors[3];
    $colors[3]=$colors[2];
    $colors[2]=$tmp;
    $tmp=$colors[4];
    $colors[4]=$colors[5];
    $colors[5]=$tmp;
    $this->image_grad(1,$colors,$xfrom,$yto/2+1,$xto,$yto,$transparency);
  }
}



function random_pixels($colors=array(),$xfrom=0,$yfrom=0,$xto=-1,$yto=-1,$transparency=NULL)
{
  $xto=$xto<0 ? $this->image_width : $xto;
  $yto=$yto<0 ? $this->image_height : $yto;

  for($i=$xfrom;$i<=$xto;$i++)
  {
    for($j=$yfrom;$j<=$yto;$j++)
    {
      $r=mt_rand()%($colors[0]-$colors[1])+$colors[1];

      if(count($colors)>2)
      {
        $g=mt_rand()%($colors[2]-$colors[3])+$colors[3];
        $b=mt_rand()%($colors[4]-$colors[5])+$colors[5];
      }
      else
      {
        $g=$r;
        $b=$r;
      }

      $this->image_pixel($i,$j,$this->rgb($r,$g,$b,$transparency));
    }
  }
}



function graph_set_center($xcenter=0,$ycenter=0)
{
  $this->graph_xcenter=$xcenter;
  $this->graph_ycenter=$ycenter;
}

function graph_set_scale($xscale=-1,$yscale=-1)
{
  $this->graph_xscale=$xscale<0 ? $this->net_stepx : $xscale;
  $this->graph_yscale=$yscale<0 ? $this->net_stepy : $yscale;
}

function graph_set_bounds($bound=false,$xfrom=0,$yfrom=0,$xto=-1,$yto=-1)
{
  $this->graph_bound=$bound;
  $this->graph_xfrom=$xfrom;
  $this->graph_yfrom=$this->image_height-$yfrom;
  $this->graph_xto=$xto<0 ? $this->image_width : $xto;
  $this->graph_yto=$yto<0 ? 0 : $this->image_height-$yto;
}

function graph_set_precision($precision=1)
{
  $this->graph_precision=$precision;
}



function graph($func='0',$handle_errors=true)
{
  if($handle_errors)
    @ob_start();

  $oldx=-$this->graph_xcenter+$this->graph_xfrom;

  $xfrom=!$this->graph_bound ? -$this->graph_xcenter : -($this->graph_xfrom+$this->graph_xcenter);
  $xto=!$this->graph_bound ? $this->image_width-$this->graph_xcenter : $this->graph_xto+$this->graph_xcenter;

  for($i=$xfrom;$i<=$xto;$i+=$this->graph_precision)
  {
    if($handle_errors)
      eval('$x=$i;$y=$this->image_height-('.$func.');');
    else
      @eval('$x=$i;$y=$this->image_height-('.$func.');');

    if($handle_errors && ob_get_length()>0)
    {
      @ob_clean();
      continue;
    }

    $y=$y*$this->graph_yscale+$this->image_height*(1-$this->graph_yscale);

    if(!isset($oldy))
      $oldy=$y;

    $tmp=$x*$this->graph_xscale;

    if(!$this->graph_bound || ($oldy<=$this->graph_yfrom && $oldy>=$this->graph_yto && $y<=$this->graph_yfrom && $y>=$this->graph_yto && $tmp>=$this->graph_xfrom && $tmp<=$this->graph_xto))
    {
      $tmp1=$y-$this->graph_ycenter;
      $tmp2=$oldy-$this->graph_ycenter;
      $tmp3=-$this->image_height*$this->graph_precision;
      $tmp4=$this->image_height*(1+$this->graph_precision);

      if($tmp1>=$tmp3 && $tmp2>=$tmp3 && $tmp1<=$tmp4 && $tmp2<=$tmp4)
        $this->image_line(round($oldx*$this->graph_xscale)+$this->graph_xcenter,$tmp2,$tmp+$this->graph_xcenter,$tmp1);
    }

    $oldx=$x;
    $oldy=$y;
  }

  if($handle_errors)
    @ob_end_clean();
}



function axis_set_center($xcenter=0,$ycenter=0)
{
  $this->axis_xcenter=$xcenter;
  $this->axis_ycenter=$this->image_height-$ycenter;
}

function axis_set_length($backlength=-1,$frontlength=-1)
{
  $this->axis_backlength=$backlength;
  $this->axis_frontlength=$frontlength;
}

function axis_set_signes($makesign=false,$signnum=1,$signstep=1)
{
  $this->axis_makesign=$makesign;
  $this->axis_signnum=$signnum;
  $this->axis_signstep=$signstep;
}

function axis_set_sign_pos($signx=4,$signy=12)
{
  $this->axis_signx=$signx;
  $this->axis_signy=$signy;
}

function axis_set_sign_color($signcolor=NULL)
{
  $this->axis_signcolor=$signcolor;
}

function axis_set_symbols($symbols=array())
{
  $this->axis_symbols=$symbols;
}

function axis_set_start($signfrom=0)
{
  $this->axis_signfrom=$signfrom;
}

function axis_set_arrows($backarrow=false,$frontarrow=true,$arrowx=12,$arrowy=3)
{
  $this->axis_backarrow=$backarrow;
  $this->axis_frontarrow=$frontarrow;
  $this->axis_arrowx=$arrowx;
  $this->axis_arrowy=$arrowy;
}

function axis_set_rules($rules1=false,$rules2=false,$linterval=5,$binterval=20,$little=3,$big=8)
{
  $this->axis_rules1=$rules1;
  $this->axis_rules2=$rules2;
  $this->axis_linterval=$linterval;
  $this->axis_binterval=$binterval;
  $this->axis_little=$little;
  $this->axis_big=$big;
}


function axis_set_round($rn=-1)
{
  $this->axis_round=$rn;
}



function make_axis($type=0)
{
  if($type==0)
  {
    $backlength=$this->axis_backlength<0 ? $this->image_width : $this->axis_backlength;
    $frontlength=$this->axis_frontlength<0 ? $this->image_width : $this->axis_frontlength;

    $backlength=($this->axis_xcenter-$backlength)<0 ? 0 : $this->axis_xcenter-$backlength;
    $frontlength=($this->axis_xcenter+$frontlength)>$this->image_width ? $this->image_width : $this->axis_xcenter+$frontlength;

    $this->image_line($backlength,$this->axis_ycenter,$this->axis_xcenter,$this->axis_ycenter);
    $this->image_line($this->axis_xcenter,$this->axis_ycenter,$frontlength,$this->axis_ycenter);

    if($this->axis_rules1 && $this->axis_frontarrow)
      $mns=$frontlength-$this->axis_arrowx;
    else
      $mns=$frontlength;

    if($this->axis_rules2 && $this->axis_backarrow)
      $pls=$backlength+$this->axis_arrowx;
    else
      $pls=$backlength;

    if($this->axis_rules1)
    {
      for($i=$this->axis_xcenter;$i>=$pls;$i-=$this->axis_linterval)
      {
        if($i%$this->axis_binterval!=0)
          $this->image_line($i,$this->axis_ycenter,$i,$this->axis_ycenter-$this->axis_little,NULL,1);
        else
          $this->image_line($i,$this->axis_ycenter,$i,$this->axis_ycenter-$this->axis_big,NULL,1);
      }

      for($i=$this->axis_xcenter;$i<=$mns;$i+=$this->axis_linterval)
      {
        if($i%$this->axis_binterval!=0)
          $this->image_line($i,$this->axis_ycenter,$i,$this->axis_ycenter-$this->axis_little,NULL,1);
        else
          $this->image_line($i,$this->axis_ycenter,$i,$this->axis_ycenter-$this->axis_big,NULL,1);
      }
    }

    if($this->axis_rules2)
    {
      for($i=$this->axis_xcenter;$i>=$pls;$i-=$this->axis_linterval)
      {
        if($i%$this->axis_binterval!=0)
          $this->image_line($i,$this->axis_ycenter,$i,$this->axis_ycenter+$this->axis_little,NULL,1);
        else
          $this->image_line($i,$this->axis_ycenter,$i,$this->axis_ycenter+$this->axis_big,NULL,1);
      }

      for($i=$this->axis_xcenter;$i<=$mns;$i+=$this->axis_linterval)
      {
        if($i%$this->axis_binterval!=0)
          $this->image_line($i,$this->axis_ycenter,$i,$this->axis_ycenter+$this->axis_little,NULL,1);
        else
          $this->image_line($i,$this->axis_ycenter,$i,$this->axis_ycenter+$this->axis_big,NULL,1);
      }
    }


    if($this->axis_frontarrow)
      $this->image_polygon(array($frontlength,$this->axis_ycenter,$frontlength-$this->axis_arrowx,$this->axis_ycenter-$this->axis_arrowy,$frontlength-$this->axis_arrowx,$this->axis_ycenter+$this->axis_arrowy),3,null,true);

    if($this->axis_backarrow)
      $this->image_polygon(array($backlength,$this->axis_ycenter,$backlength+$this->axis_arrowx,$this->axis_ycenter-$this->axis_arrowy,$backlength+$this->axis_arrowx,$this->axis_ycenter+$this->axis_arrowy),3,null,true);

    if($this->axis_makesign)
    {
      for($i=$this->axis_xcenter,$cnt=0;$i<=$frontlength;$i+=$this->axis_signstep,$cnt++)
      {
        $sign1=$cnt*$this->axis_signnum+$this->axis_signfrom;

        if($this->axis_round>=0)
          $sign1=round($sign1,$this->axis_round);

        if(isset($this->axis_symbols[$cnt])) $sign1=$this->axis_symbols[$cnt];

        $tmpx=$this->maxttfxsize($sign1)/2;

        if($i!=$this->image_width)
          $this->image_ttf_text($sign1,$i-$tmpx+$this->axis_signx,$this->axis_ycenter+$this->axis_signy,true,0,0,$this->axis_signcolor);
      }

      for($i=$this->axis_xcenter,$cnt=0;$i>=$backlength;$i-=$this->axis_signstep,$cnt++)
      {
        $sign1=$cnt*$this->axis_signnum+$this->axis_signfrom;

        $sign1=-$sign1;

        if($this->axis_round>=0)
          $sign1=round($sign1,$this->axis_round);

        if($sign1==0) $sign1='';

        if(isset($this->axis_symbols[$cnt]) && $sign1!=0) $sign1=$this->axis_symbols[$cnt];

        $tmpx=$this->maxttfxsize($sign1)/2;

        if($i!=$this->axis_xcenter && $i!=0)
          $this->image_ttf_text($sign1,$i-$tmpx+$this->axis_signx,$this->axis_ycenter+$this->axis_signy,true,0,0,$this->axis_signcolor);
      }
    }
  }

  if($type==1)
  {
    $backlength=$this->axis_backlength<0 ? $this->image_height : $this->axis_backlength;
    $frontlength=$this->axis_frontlength<0 ? $this->image_height : $this->axis_frontlength;

    $backlength=($this->axis_ycenter+$backlength)>$this->image_height ? $this->image_height : $this->axis_ycenter+$backlength;
    $frontlength=($this->axis_ycenter-$frontlength)<0 ? 0 : $this->axis_ycenter-$frontlength;

    $this->image_line($this->axis_xcenter,$backlength,$this->axis_xcenter,$this->axis_ycenter);
    $this->image_line($this->axis_xcenter,$this->axis_ycenter,$this->axis_xcenter,$frontlength);

    if($this->axis_rules1 && $this->axis_frontarrow)
      $mns=$frontlength+$this->axis_arrowx;
    else
      $mns=$frontlength;

    if($this->axis_rules2 && $this->axis_backarrow)
      $pls=$backlength-$this->axis_arrowx;
    else
      $pls=$backlength;

    if($this->axis_rules1)
    {
      for($i=$this->axis_ycenter;$i<=$pls;$i+=$this->axis_linterval)
      {
        if($i%$this->axis_binterval!=0)
          $this->image_line($this->axis_xcenter,$i,$this->axis_xcenter-$this->axis_little,$i,NULL,1);
        else
          $this->image_line($this->axis_xcenter,$i,$this->axis_xcenter-$this->axis_big,$i,NULL,1);
      }

      for($i=$this->axis_ycenter;$i>=$mns;$i-=$this->axis_linterval)
      {
        if($i%$this->axis_binterval!=0)
          $this->image_line($this->axis_xcenter,$i,$this->axis_xcenter-$this->axis_little,$i,NULL,1);
        else
          $this->image_line($this->axis_xcenter,$i,$this->axis_xcenter-$this->axis_big,$i,NULL,1);
      }
    }

    if($this->axis_rules2)
    {
      for($i=$this->axis_ycenter;$i<=$pls;$i+=$this->axis_linterval)
      {
        if($i%$this->axis_binterval!=0)
          $this->image_line($this->axis_xcenter,$i,$this->axis_xcenter+$this->axis_little,$i,NULL,1);
        else
          $this->image_line($this->axis_xcenter,$i,$this->axis_xcenter+$this->axis_big,$i,NULL,1);
      }

      for($i=$this->axis_ycenter;$i>=$mns;$i-=$this->axis_linterval)
      {
        if($i%$this->axis_binterval!=0)
          $this->image_line($this->axis_xcenter,$i,$this->axis_xcenter+$this->axis_little,$i,NULL,1);
        else
          $this->image_line($this->axis_xcenter,$i,$this->axis_xcenter+$this->axis_big,$i,NULL,1);
      }
    }

    if($this->axis_frontarrow)
      $this->image_polygon(array($this->axis_xcenter,$frontlength,$this->axis_xcenter-$this->axis_arrowy,$frontlength+$this->axis_arrowx,$this->axis_xcenter+$this->axis_arrowy,$frontlength+$this->axis_arrowx),3,null,true);

    if($this->axis_backarrow)
      $this->image_polygon(array($this->axis_xcenter,$backlength,$this->axis_xcenter-$this->axis_arrowy,$backlength-$this->axis_arrowx,$this->axis_xcenter+$this->axis_arrowy,$backlength-$this->axis_arrowx),3,null,true);

    if($this->axis_makesign)
    {
      $tmpy=$this->maxttfysize('A')/2;

      for($i=$this->axis_ycenter,$cnt=0;$i>=$frontlength;$i-=$this->axis_signstep,$cnt++)
      {
        $sign1=$cnt*$this->axis_signnum+$this->axis_signfrom;

        if($this->axis_round>=0)
          $sign1=round($sign1,$this->axis_round);

        if(isset($this->axis_symbols[$cnt])) $sign1=$this->axis_symbols[$cnt];

        if($i!=0)
          $this->image_ttf_text($sign1,$this->axis_xcenter+$this->axis_signx,$i-$tmpy+$this->axis_signy,true,0,0,$this->axis_signcolor);
      }

      for($i=$this->axis_ycenter,$cnt=0;$i<=$backlength;$i+=$this->axis_signstep,$cnt++)
      {
        $sign1=$cnt*$this->axis_signnum+$this->axis_signfrom;

        $sign1=-$sign1;

        if($this->axis_round>=0)
          $sign1=round($sign1,$this->axis_round);

        if($sign1==0) $sign1='';
        if(isset($this->axis_symbols[$cnt]) && $sign1!=0) $sign1=$this->axis_symbols[$cnt];

        if($i!=$this->image_height && $i!=$this->axis_ycenter)
          $this->image_ttf_text($sign1,$this->axis_xcenter+$this->axis_signx,$i-$tmpy+$this->axis_signy,true,0,0,$this->axis_signcolor);
      }
    }
  }
}




function maxttfxsize($txt='',$size=-1)
{
  if($size<0)
    $size=$this->font_size;

  $tmp=$this->imagettfbbox_fixed($size,$this->font_angle,$this->font,$txt);
  $tmpx1=$tmp[0]>$tmp[6] ? $tmp[0] : $tmp[6];
  $tmpx2=$tmp[2]>$tmp[4] ? $tmp[2] : $tmp[4];
  return $tmpx2-$tmpx1;
}



function maxttfysize($txt='',$size=-1)
{
  if($size<0)
    $size=$this->font_size;

  $tmp=$this->imagettfbbox_fixed($size,$this->font_angle,$this->font,$txt);
  $tmpy1=$tmp[1]>$tmp[3] ? $tmp[1] : $tmp[3];
  $tmpy2=$tmp[5]>$tmp[7] ? $tmp[5] : $tmp[7];
  return $tmpy2-$tmpy1;
}


function imagettfbbox_fixed($size,$angle,$font,$text)
{
  $tmp=imagettfbbox($size,0,$font,$text);

  $box=array();
  $cosn=cos(deg2rad($angle));
  $sinn=sin(deg2rad($angle));

  for($i=0;$i<7;$i+=2)
  {
    list($x,$y)=array($tmp[$i],$tmp[$i+1]);
    $box[$i]=round($x*$cosn+$y*$sinn);
    $box[$i+1]=round($y*$cosn-$x*$sinn);
  }

  return $box;
}



function diagram_set_center($x=0,$y=0)
{
  $this->diagram_x=$x;
  $this->diagram_y=$this->image_height-$y;
}

function diagram_set_size($width=17,$step=3,$max_height=150)
{
  $this->diagram_width=$width;
  $this->diagram_step=$step;
  $this->diagram_max_height=$max_height;
}

function diagram_set_signes($signed=true,$signcolor=NULL)
{
  $this->diagram_signed=$signed;
  $this->diagram_signcolor=$signcolor;
}

function diagram_set_sign_params($prefix='',$index='')
{
  $this->diagram_index=$index;
  $this->diagram_prefix=$prefix;
}

function diagram_set_sign_pos($txtx=5,$txty=5)
{
  $this->diagram_txtx=$txtx;
  $this->diagram_txty=$txty;
}

function diagram_set_colors($colors=array())
{
  $this->diagram_colors=$colors;
}

function diagram_set_shadow($shadowx=0,$shadowy=0,$shadowtransparency=60,$shadowcolors=array())
{
  $this->diagram_shadowx=$shadowx;
  $this->diagram_shadowy=$shadowy;
  $this->diagram_shadowtransparency=$shadowtransparency;
  $this->diagram_shadowcolors=$shadowcolors;
}

function diagram_set_nums($divider=1,$hround=5)
{
  if(!$divider) $divider=1;
  $this->diagram_round=$hround;
  $this->diagram_divider=$divider;
}



function column_diagram($values)
{
  $this->lastcolors=array();

  if(!$values || gettype($values)!="array")
    return false;

  $max_elem=0;

  $pos=0;
  $names=array();
  $heights=array();

  foreach($values as $val)
  {
    if($val>$max_elem)
      $max_elem=$val;

    $names[]=$val;
  }

  $i=0;

  foreach($values as $val)
  {
    if($this->diagram_colors[0]!='rand' && $this->diagram_colors[0]!='fix')
    {
      if($this->diagram_colors[$i]!=0)
        $scolor=$this->diagram_colors[$i];
      else
        $scolor=$this->color;
    }
    else if($this->diagram_colors[0]=='rand')
    {
      $r=mt_rand()%($this->diagram_colors[2]-$this->diagram_colors[1])+$this->diagram_colors[1];

      if(count($this->diagram_colors)<4)
      {
        $g=$r;
        $b=$r;
      }
      else
      {
        $g=mt_rand()%($this->diagram_colors[4]-$this->diagram_colors[3])+$this->diagram_colors[3];
        $b=mt_rand()%($this->diagram_colors[6]-$this->diagram_colors[5])+$this->diagram_colors[5];
      }
   
      $scolor=$this->rgb($r,$g,$b);
    }
    else
    {
      $r=$this->diagram_colors[1];
      $g=$this->diagram_colors[2];
      $b=$this->diagram_colors[3];
      $scolor=$this->rgb($this->diagram_colors[1],$this->diagram_colors[2],$this->diagram_colors[3]);
    }

    $this->lastcolors[]=$scolor;

    $height=$this->diagram_y-round($this->diagram_max_height*$val/$max_elem);

    if($this->diagram_shadowx!=0 || $this->diagram_shadowy!=0)
    {
      if(isset($r)) $scolor2=$this->rgb($r,$g,$b,$this->diagram_shadowtransparency);
      elseif($scolor==NULL) $scolor2=$this->rgb($this->r,$this->g,$this->b,$this->diagram_shadowtransparency);

      if($this->diagram_shadowcolors[0]=='auto')
        $scolor2=NULL;
      elseif(isset($this->diagram_shadowcolors[$i]))
        $scolor2=$this->rgb($this->diagram_shadowcolors[$i][0],$this->diagram_shadowcolors[$i][1],$this->diagram_shadowcolors[$i][2],$this->diagram_shadowtransparency);

      $this->image_rectangle($this->diagram_x+$pos+$this->diagram_shadowx,$height+$this->diagram_shadowy,$this->diagram_x+$pos+$this->diagram_width+$this->diagram_shadowx,$this->diagram_y+$this->diagram_shadowy,$scolor2);
    }

    $this->image_rectangle($this->diagram_x+$pos,$height,$this->diagram_x+$pos+$this->diagram_width,$this->diagram_y,$scolor);

    if($this->point)
    {
      $d=$height>$this->diagram_y ? 1 : 0;
      $s=$height>$this->diagram_y ? -1 : 1;
      imagecopy($this->image,$this->point,$this->diagram_x+$pos+$this->diagram_width+$this->point_x,$height-$s*$this->point_y-$d*$this->point_height,0,0,$this->point_width,$this->point_height);
    }

    $i++;

    $pos=$pos+$this->diagram_width+$this->diagram_step;
    $heights[]=$height;
  }

  if($this->diagram_signed)
  {
    $pos=0;

    for($i=0,$cnt=count($names);$i<$cnt;$i++)
    {
      if(!isset($this->diagram_signes[$i]))
      {
        $tmpz=str_replace(' ','.',round($names[$i]/$this->diagram_divider,$this->diagram_round));

        $tmpy=$this->maxttfysize($this->diagram_prefix.$tmpz.$this->diagram_index)/2;
        $tmpx=($this->diagram_width+$this->diagram_step-$this->maxttfxsize($this->diagram_prefix.$tmpz.$this->diagram_index))/2;
        $txt=$this->diagram_prefix.$tmpz.$this->diagram_index;
      }
      else
      {
        $tmpy=$this->maxttfysize($this->diagram_signes[$i])/2;
        $tmpx=($this->diagram_width+$this->diagram_step-$this->maxttfxsize($this->diagram_signes[$i]))/2;
        $txt=$this->diagram_signes[$i];
      }

      $s=$heights[$i]>$this->diagram_y ? -1 : 1;
      $d=$heights[$i]>$this->diagram_y ? 1 : 0;

      $this->image_ttf_text($txt,$this->diagram_x+$pos+$tmpx+$this->diagram_txtx,$heights[$i]-$s*$this->diagram_txty-$d*$tmpy,true,0,0,$this->diagram_signcolor);
      $pos+=$this->diagram_width+$this->diagram_step;

    }
  }

  $this->lastcolors=array_reverse($this->lastcolors);
}



function string_diagram($values)
{
  $this->lastcolors=array();

  if(!$values || gettype($values)!="array")
    return false;

  $max_elem=0;

  $pos=0;
  $names=array();
  $heights=array();

  $values=array_reverse($values,true);

  foreach($values as $val)
  {
    if($val>$max_elem)
      $max_elem=$val;

    $names[]=$val;
  }

  $i=0;

  foreach($values as $val)
  {
    if($this->diagram_colors[0]!='rand' && $this->diagram_colors[0]!='fix')
    {
      if($this->diagram_colors[$i]!=0)
        $scolor=$this->diagram_colors[$i];
      else
        $scolor=$this->color;
    }
    else if($this->diagram_colors[0]=='rand')
    {
      $r=mt_rand()%($this->diagram_colors[2]-$this->diagram_colors[1])+$this->diagram_colors[1];

      if(count($this->diagram_colors)<4)
      {
        $g=$r;
        $b=$r;
      }
      else
      {
        $g=mt_rand()%($this->diagram_colors[4]-$this->diagram_colors[3])+$this->diagram_colors[3];
        $b=mt_rand()%($this->diagram_colors[6]-$this->diagram_colors[5])+$this->diagram_colors[5];
      }

      $scolor=$this->rgb($r,$g,$b);
    }
    else
    {
      $r=$this->diagram_colors[1];
      $g=$this->diagram_colors[2];
      $b=$this->diagram_colors[3];
      $scolor=$this->rgb($this->diagram_colors[1],$this->diagram_colors[2],$this->diagram_colors[3]);
    }

    $this->lastcolors[]=$scolor;

    $height=round($this->diagram_max_height*$val/$max_elem);

    if($this->diagram_shadowx!=0 || $this->diagram_shadowy!=0)
    {
      if(isset($r)) $scolor2=$this->rgb($r,$g,$b,$this->diagram_shadowtransparency);
      elseif($scolor==NULL) $scolor2=$this->rgb($this->r,$this->g,$this->b,$this->diagram_shadowtransparency);

      if($this->diagram_shadowcolors[0]=='auto')
        $scolor2=NULL;
      elseif(isset($this->diagram_shadowcolors[$i]))
        $scolor2=$this->rgb($this->diagram_shadowcolors[$i][0],$this->diagram_shadowcolors[$i][1],$this->diagram_shadowcolors[$i][2],$this->diagram_shadowtransparency);

      $this->image_rectangle($this->diagram_x+$this->diagram_shadowx,$this->diagram_y-$pos+$this->diagram_shadowy,$height+$this->diagram_x+$this->diagram_shadowx,$this->diagram_y-$pos-$this->diagram_width+$this->diagram_shadowy,$scolor2);
    }

    $this->image_rectangle($this->diagram_x,$this->diagram_y-$pos,$height+$this->diagram_x,$this->diagram_y-$pos-$this->diagram_width,$scolor);

    if($this->point)
    {
      $d=$height<0 ? -1 : 0;
      imagecopy($this->image,$this->point,$d*$this->point_width+$height+$this->diagram_x+$this->point_x,$this->diagram_y-$pos-$this->point_y,0,0,$this->point_width,$this->point_height);
    }

    $i++;

    $pos=$pos+$this->diagram_width+$this->diagram_step;
    $heights[]=$height;
  }

  if($this->diagram_signed)
  {
    $pos=0;

    for($i=0,$cnt=count($names);$i<$cnt;$i++)
    {
      if(!isset($this->diagram_signes[$i]))
      {
        $tmpz=str_replace(' ','.',round($names[$i]/$this->diagram_divider,$this->diagram_round));
        $tmpy=$this->maxttfysize($this->diagram_prefix.$tmpz.$this->diagram_index)/2;
        $tmpx=$this->maxttfxsize($this->diagram_prefix.$tmpz.$this->diagram_index);

        $txt=$this->diagram_prefix.$tmpz.$this->diagram_index;
      }
      else
      {
        $tmpy=$this->maxttfysize($this->diagram_signes[$i])/2;
        $tmpx=$this->maxttfxsize($this->diagram_signes[$i]);
        $txt=$this->diagram_signes[$i];
      }

      $d=$heights[$i]<0 ? -1 : 0;
      $s=$heights[$i]<0 ? -1 : 1;

      $this->image_ttf_text($txt,$heights[$i]+$this->diagram_x+$s*$this->diagram_txtx+$tmpx*$d,$this->diagram_y-$pos+$tmpy-$this->diagram_txty,true,0,0,$this->diagram_signcolor);
      $pos=$pos+$this->diagram_width+$this->diagram_step;
    }
  }
  $this->lastcolors=array_reverse($this->lastcolors);
}



function graph_points_horizontal($points,$signs=array())
{
  $tmparr=array();

  if(!$points || gettype($points)!="array")
    return false;

  $cnt2=0;
  $cnt=0;

  foreach($points as $point)
  {
    $tmparr[$cnt2+2]=$point[0];
    $tmparr[$cnt2+3]=$point[1];

    $cnt2+=2;
    $cnt++;
  }

  if($this->isfilled)
  {
    $tmparr[0]=$this->hgraph_x;
    $tmparr[1]=$this->hgraph_y;
    $tmparr[$cnt2+2]=$tmparr[$cnt2];
    $tmparr[$cnt2+3]=$this->hgraph_y;

    $this->image_polygon($tmparr,$cnt+2,$this->hgraph_fillcolor);
  }

  $cnt=0;

  foreach($points as $point)
  {
    if(!isset($oldx)) $oldx=$point[0];
    if(!isset($oldy)) $oldy=$point[1];

    if(!$this->hgraph_hidelines)
      $this->image_line($oldx,$oldy,$point[0],$point[1]);

    $oldx=$point[0];
    $oldy=$point[1];
    $cnt++;
  }

  if($this->point)
  {
    foreach($points as $point)
    {
      if($this->point)
        imagecopy($this->image,$this->point,$point[0]+$this->point_x,$point[1]-$this->point_y,0,0,$this->point_width,$this->point_height);
    }
  }

  $cnt=0;

  if($this->hgraph_signed)
  {
    foreach($points as $point)
    {
      $s=$point[1]>$this->hgraph_y ? -1 : 1;
      $this->image_ttf_text($signs[$cnt],$point[0]+$this->hgraph_sx,$point[1]-$this->hgraph_sy*$s,true,0,0,$this->hgraph_signcolor);
      $cnt++;
    }
  }
}



function hgraph_set_center($x=0,$y=0)
{
  $this->hgraph_x=$x;
  $this->hgraph_y=$this->image_height-$y;
}

function hgraph_set_params($maxheight=100,$interval=20,$hidelines=false)
{
  $this->hgraph_maxheight=$maxheight;
  $this->hgraph_interval=$interval;
  $this->hgraph_hidelines=$hidelines;
}

function hgraph_set_signes($signed=true,$sx=0,$sy=0,$index='',$prefix='',$signcolor=NULL,$signs=array())
{
  $this->hgraph_signed=$signed;
  $this->hgraph_sx=$sx;
  $this->hgraph_sy=$sy;
  $this->hgraph_signcolor=$signcolor;
  $this->hgraph_signs=$signs;
  $this->hgraph_index=$index;
  $this->hgraph_prefix=$prefix;
}

function hgraph_set_nums($divider=1,$hround=5)
{
  if(!$divider) $divider=1;
  $this->hgraph_round=$hround;
  $this->hgraph_divider=$divider;
}

function hgraph_set_fillcolor($fillcolor=NULL)
{
  $this->hgraph_fillcolor=$fillcolor;
}

function hlegend_set_linelen($linelen=10)
{
  $this->hlegend_linelen=$linelen;
}

function hgraph_add_to_legend($addline=true,$addpoint=true)
{
  $this->hlegends[]=array(0 => $addline, 1 => $addpoint, 2 => $this->color, 3 => $this->point_filename, 4 => $this->point_width, 5 => -$this->point_height, 6 => $this->point_filetype);
}

function hlegent_destroy()
{
  $this->hlegends=array();
}



function make_hgraph_legend()
{
  $maxlen=0;
  $ysize=0;
  $x=$this->legend_x;
  $y=$this->legend_y;

  $cnt=count($this->hlegends);
  $cnt2=0;

  $heights=array();
  $xmax=0;
  $ss=1;

  $yonesize=$this->maxttfysize('A');

  $legend_texts=array_reverse($this->legend_texts);

  foreach($this->hlegends as $lnd)
  {
    $tmp=$this->maxttfxsize($legend_texts[$cnt2]);
    $tmp2=$this->maxttfysize($legend_texts[$cnt2]);

    if($lnd[1] && $lnd[3])
    {
      $tmp2=$lnd[5]<$tmp2 ? $lnd[5] : $tmp2;

      if($lnd[4]>$xmax)
        $xmax=$lnd[4];
    }

    if($tmp>$maxlen)
      $maxlen=$tmp;
    $ysize+=$tmp2;

    $heights[]=$tmp2;

    $cnt2++;
  }

  if($lnd[0] && $this->hlegend_linelen>$xmax)
    $xmax=$this->hlegend_linelen;

    $add=$xmax ? $xmax+2 : 0;

  if($this->legend_name)
  {
    $add3=$this->legend_name_size<0 ? $this->font_size : $this->legend_name_size;
    $titleh=$this->maxttfysize($this->legend_name,$add3);
    $add2=-$titleh+$this->legend_fields;
    $titlelen=$this->maxttfxsize($this->legend_name,$add3);
    $maxlen=$maxlen>$titlelen ? $maxlen : $titlelen;
    //$yonesize2=$this->maxttfysize('A',$add3);
  }
  else
  {
    $add2=0;
    //$yonesize2=$yonesize;
  }

  $nxsize=$maxlen+$this->legend_fields*2+$add;
  $nysize=-$ysize+$this->legend_fields+$this->legend_strinterval*$cnt2+$add2;

  $this->image_rectangle($x,$y,$x+$nxsize,$y+$nysize);
  if($this->legend_bordercolor)
    $this->image_rectangle($x,$y,$x+$nxsize,$y+$nysize,$this->legend_bordercolor,true,$this->legend_borderwidth);

  $x+=$this->legend_fields;
  $y=$y+$this->legend_fields;//-$yonesize2

  if($this->legend_name)
  {
    $this->image_ttf_text($this->legend_name,$x+($nxsize-$titlelen)/2-$this->legend_fields,$y+$add3,true,false,0,$this->legend_name_fontcolor,$this->legend_name_size,$this->legend_fontname);
    //$y+=$add2-$heights[0]+$this->legend_strinterval;
  }

  $tmpc=0;
  if(!isset($titleh))
    $titleh=0;

  //$y+=-$titleh-$yonesize+$this->legend_strinterval;

  $y+=-$ysize;

  foreach($this->hlegends as $lnd)
  {
      if($this->legend_colortext)
        $tcolor=$lnd[2];
      else
        $tcolor=$this->legend_fontcolor;

      $this->image_ttf_text($legend_texts[$tmpc],$x+$add,$y+$ysize-$titleh-($lnd[5]+$yonesize)/2,true,false,0,$tcolor);

      $tx=($xmax-$lnd[4])/2;

      if($this->tiled || $this->styled || $this->brushed)
        $clr=NULL;
      else
        $clr=$lnd[2];

      if($lnd[0])
        $this->image_line($x+$add-$this->hlegend_linelen-1,$y+$ysize-$titleh-$lnd[5]/2,$x+$add-1,$y+$ysize-$titleh-$lnd[5]/2,$clr);

      if($lnd[1])
        $this->paste_image($lnd[3],$lnd[6],false,$x+$add-2-$xmax+$tx,$y+$ysize-$titleh);


      $y-=$heights[$tmpc]-$this->legend_strinterval;
      $tmpc++;
  }
}




function graph_horizontal($points)
{
  $pos=0;
  $maxelem=$points[0];
  $newpoints=array();
  $cnt=0;

  foreach($points as $point)
  {
    if($point>$maxelem)
      $maxelem=$point;
  }

  if($maxelem==0) $maxelem=1;

  foreach($points as $point)
  {
    $newy=$this->hgraph_y-round($this->hgraph_maxheight*($point/$maxelem));
    $newpoints[]=array($pos+$this->hgraph_x,$newy);
    $pos+=$this->hgraph_interval;

    if($this->hgraph_signed)
    {
      if(isset($this->hgraph_signs[$cnt]))
      {
        $nsigns[]=$this->hgraph_signs[$cnt];
      }
      else
      {
        $tmp=str_replace(' ','.',round(($this->hgraph_y-$newy)/$this->hgraph_divider,$this->hgraph_round));
        $nsigns[]=$this->hgraph_prefix.$tmp.$this->hgraph_index;
      }
    }

    $cnt++;
  }

  $this->graph_points_horizontal($newpoints,$nsigns);
}



function image_polygon($points,$num_points,$fillcolor=NULL,$filled=false)
{
  if($this->tiled && ($this->isfilled || $filled) && $this->tile)
    $color=IMG_COLOR_TILED;
  else
    $color=$this->color;

  if($this->styled && $this->style)
    $color=IMG_COLOR_STYLED;

  if($this->brushed && $this->brush)
    $color=IMG_COLOR_BRUSHED;

  if($fillcolor!=NULL)
    $color=$fillcolor;

  if(!($this->isfilled || $filled))
    return imagepolygon($this->image,$points,$num_points,$color);
  else
    return imagefilledpolygon($this->image,$points,$num_points,$color);
}



function legend_set_pos($x=0,$y=0)
{
  $this->legend_x=$x;
  $this->legend_y=$this->image_height-$y;
}

function legend_set_texts($texts=array())
{
  $this->legend_texts=array_reverse($texts);
}

function legend_set_fields($fields=5)
{
  $this->legend_fields=$fields;
}

function legend_set_border($bordercolor=NULL,$borderwidth=1)
{
  $this->legend_bordercolor=$bordercolor;
  $this->legend_borderwidth=$borderwidth;
}

function dlegend_set_boxes($colorboxes=false,$type=0,$boxbordercolor=NULL)
{
  $this->dlegend_colorboxes=$colorboxes;
  $this->dlegend_boxbordercolor=$boxbordercolor;
  $this->dlegend_type=$type;
}

function legend_set_fontcolor($fontcolor=NULL,$colortext=false)
{
  $this->legend_fontcolor=$fontcolor;
  $this->legend_colortext=$colortext;
}

function legend_set_fontname($fontname='')
{
  $this->legend_fontname=$fontname;
}

function legend_set_strinterval($strinterval=2)
{
  $this->legend_strinterval=$strinterval;
}

function legend_set_name($name='',$size=-1,$fontcolor=NULL)
{
  $this->legend_name=$name;
  $this->legend_name_size=$size;
  $this->legend_name_fontcolor=$fontcolor;
}



function make_diagram_legend()
{
  $maxlen=0;
  $ysize=0;
  $x=$this->legend_x;
  $y=$this->legend_y;

  $cnt=count($this->lastcolors);
  $cnt2=0;

  $yonesize=$this->maxttfysize('A');
  $heights=array();

  for($i=0;$i<$cnt;$i++)
  {
    if(isset($this->legend_texts[$i]))
    {
      $tmp=$this->maxttfxsize($this->legend_texts[$i]);
      $tmp2=$this->maxttfysize($this->legend_texts[$i]);
      if($tmp>$maxlen)
        $maxlen=$tmp;
      $ysize+=$tmp2;

      $heights[]=$tmp2;

      $cnt2++;
    }
  }

  if($this->dlegend_colorboxes)
    $add=-$yonesize+2;
  else
    $add=0;

  if($this->legend_name)
  {
    $add3=$this->legend_name_size<0 ? $this->font_size : $this->legend_name_size;
    $titleh=$this->maxttfysize($this->legend_name,$add3);
    $add2=-$titleh+$this->legend_fields;
    $titlelen=$this->maxttfxsize($this->legend_name,$add3);
    $maxlen=$maxlen>$titlelen ? $maxlen : $titlelen;
    $yonesizeb=$this->maxttfxsize('A',$add3);
  }
  else
  {
    $add2=0;
    $yonesizeb=0;
  }

  $nxsize=$maxlen+$this->legend_fields*2+$add;
  $nysize=-$ysize+$this->legend_fields+$this->legend_strinterval*$cnt2+$add2;

  $this->image_rectangle($x,$y,$x+$nxsize,$y+$nysize);
  if($this->legend_bordercolor)
    $this->image_rectangle($x,$y,$x+$nxsize,$y+$nysize,$this->legend_bordercolor,true,$this->legend_borderwidth);

  $x+=$this->legend_fields;
  $y=$y+$this->legend_fields;//-$yonesize//+$yonesizeb


  if($this->legend_name)
  {
    $this->image_ttf_text($this->legend_name,$x+($nxsize-$titlelen)/2-$this->legend_fields,$y+$add3,true,false,0,$this->legend_name_fontcolor,$this->legend_name_size,$this->legend_fontname);
    //$y+=$add2;
  }

  if(!isset($titleh))
    $titleh=0;

  //$y+=-$titleh-$yonesize+$this->legend_strinterval;

  $y+=-$ysize;
  //$y-=$titleh-$this->legend_strinterval;

  for($i=0;$i<$cnt;$i++)
  {
    if(isset($this->legend_texts[$i]))
    {
      if(!$this->dlegend_colorboxes)
      {
        $this->image_ttf_text($this->legend_texts[$i],$x,$y,true,false,0,$this->lastcolors[$cnt-$i-1]);
        $y-=$heights[$i]-$this->legend_strinterval;
      }
      else
      {
        if($this->legend_colortext)
          $tcolor=$this->lastcolors[$cnt-$i-1];
        else
          $tcolor=$this->legend_fontcolor;

        $this->image_ttf_text($this->legend_texts[$i],$x+$add,$y+$ysize-$titleh-$yonesize,true,false,0,$tcolor);
        if($this->dlegend_type==0)
          $this->image_rectangle($x,$y+$ysize-$titleh-$yonesize,$x+$add-2,$y-$add+2+$ysize-$titleh-$yonesize,$this->lastcolors[$cnt-$i-1]);
        else
          $this->image_circle($x+$add/2-2,$y-$add/2+2+$ysize-$titleh-$yonesize,$add,IMG_ARC_PIE,$this->lastcolors[$cnt-$i-1]);

        if($this->dlegend_boxbordercolor!=NULL)
        {
          if($this->dlegend_type==0)
            $this->image_rectangle($x,$y,$x+$add-2,$y-$add+2+$ysize-$titleh-$yonesize,$this->dlegend_boxbordercolor,true);
          else
            $this->image_circle($x+$add/2-2,$y-$add/2+2+$ysize-$titleh-$yonesize,$add,IMG_ARC_PIE,$this->dlegend_boxbordercolor,true);
        }

        $y-=$heights[$i]-$this->legend_strinterval;
      }
    }
  }
}



function cdiagram_set_size($max_radius=100)
{
  $this->cdiagram_max_radius=$max_radius;
}

function diagram_set_add_signes($signes=array())
{
  $this->diagram_signes=$signes;
}



function make_circle_diagram($values)
{
  $pos=0;
  $maxelem=0;
  $newpoints=array();
  $cnt=0;
  $this->lastcolors=array();
  $scolors=array();

  foreach($values as $name=>$val)
  {
    if($val>$max_elem)
      $max_elem=$val;

    $names[]=$type==0 ? $val : $name;
  }

  foreach($values as $point)
  {
    if($point>$maxelem)
      $maxelem=$point;

   $sum+=$point;
  }

  $ang=0;
  $i=0;

  foreach($values as $point)
  {
    if($this->diagram_colors[0]!='rand' && $this->diagram_colors[0]!='fix')
    {
      if($this->diagram_colors[$i]!=0)
        $scolor=$this->diagram_colors[$i];
      else
        $scolor=NULL;
    }
    else if($this->diagram_colors[0]=='rand')
    {
      $r=mt_rand()%($this->diagram_colors[1]-$this->diagram_colors[2])+$this->diagram_colors[2];

      if(count($this->diagram_colors)<4)
      {
        $g=$r;
        $b=$r;
      }
      else
      {
        $g=mt_rand()%($this->diagram_colors[3]-$this->diagram_colors[4])+$this->diagram_colors[4];
        $b=mt_rand()%($this->diagram_colors[5]-$this->diagram_colors[6])+$this->diagram_colors[6];
      }

      $scolor=$this->rgb($r,$g,$b);
    }
    else
    {
      $r=$this->diagram_colors[1];
      $g=$this->diagram_colors[2];
      $b=$this->diagram_colors[3];
      $scolor=$this->rgb($this->diagram_colors[1],$this->diagram_colors[2],$this->diagram_colors[3]);
    }

    $this->lastcolors[]=$scolor;
    $val=round((360/$sum)*$point);
    $scolors[]=$scolor;

    if($this->diagram_shadowx!=0 || $this->diagram_shadowy!=0)
    {
      if(isset($r)) $scolor2=$this->rgb($r,$g,$b,$this->diagram_shadowtransparency);
      elseif($scolor==NULL) $scolor2=$this->rgb($this->r,$this->g,$this->b,$this->diagram_shadowtransparency);

      if($this->diagram_shadowcolors[0]=='auto')
        $scolor2=NULL;
      elseif(isset($this->diagram_shadowcolors[$i]))
        $scolor2=$this->rgb($this->diagram_shadowcolors[$i][0],$this->diagram_shadowcolors[$i][1],$this->diagram_shadowcolors[$i][2],$this->diagram_shadowtransparency);

      $this->image_arc($this->diagram_x+$this->diagram_shadowx,$this->diagram_y+$this->diagram_shadowy,$this->cdiagram_max_radius,$this->cdiagram_max_radius,$ang,$ang+$val,IMG_ARC_PIE,$scolor2);
    }

    $ang+=$val;
    $i++;
  }

  $ang=0;
  $i=0;

  foreach($values as $point)
  {
    $val=round((360/$sum)*$point);
    $this->image_arc($this->diagram_x,$this->diagram_y,$this->cdiagram_max_radius,$this->cdiagram_max_radius,$ang,$ang+$val,IMG_ARC_PIE,$scolors[$i]);
    $ang+=$val;
    $i++;
  }

  $ang=0;
  $i=0;

  if($this->diagram_signed)
  {
    foreach($values as $point)
    {
      if(!isset($this->diagram_signes[$i]))
      {
        $tmpy=$this->maxttfysize($this->diagram_prefix.$names[$i].$this->diagram_index);
        $tmpx=$this->maxttfxsize($this->diagram_prefix.$names[$i].$this->diagram_index);
        $txt=$this->diagram_prefix.$names[$i].$this->diagram_index;
      }
      else
      {
        $tmpy=$this->maxttfysize($this->diagram_signes[$i]);
        $tmpx=$this->maxttfxsize($this->diagram_signes[$i]);
        $txt=$this->diagram_signes[$i];
      }

      $val=round((360/$sum)*$point);
      $tmp=deg2rad($ang+$val/2);
      $tmp2=cos($tmp);
      $tmpx=$tmp2<0 ? $tmpx : 0;
      $tmp3=sin($tmp);
      $tmpy=$tmp3>0 ? $tmpy : 0;
      $tmpx+=$this->diagram_txtx;
      $tmpy+=$this->diagram_txty;

      $this->image_ttf_text($txt,$this->diagram_x+($this->cdiagram_max_radius/2+$tmpx)*$tmp2,$this->diagram_y+($this->cdiagram_max_radius/2-$tmpy)*$tmp3,true,0,0,$this->diagram_signcolor);

      $ang+=$val;
      $i++;
    }
  }
  $this->lastcolors=array_reverse($this->lastcolors);
}



function image_reverse_colors()
{
  return imagefilter($this->image,IMG_FILTER_NEGATE);
}



function image_gray()
{
  return imagefilter($this->image,IMG_FILTER_GRAYSCALE);
}



function image_emboss()
{
  return imagefilter($this->image,IMG_FILTER_EMBOSS);
}



function image_smooth($lvl=1)
{
  return imagefilter($this->image,IMG_FILTER_SMOOTH,$lvl);
}



function image_remove_mean()
{
  return imagefilter($this->image,IMG_FILTER_MEAN_REMOVAL);
}



function image_set_brightness($lvl=0)
{
  return imagefilter($this->image,IMG_FILTER_BRIGHTNESS,$lvl);
}



function image_set_contrast($lvl=0)
{
  return imagefilter($this->image,IMG_FILTER_CONTRAST,$lvl);
}



function image_pixel($x=0,$y=0,$scolor=NULL)
{
  if(!$scolor)
    $scolor=$this->color;

  return imagesetpixel($this->image,$x,$y,$scolor);
}




function paste_image($file,$type=0,$copyresized=false,$dst_x=0,$dst_y=0,$src_x=0,$src_y=0,$src_w=-1,$src_h=-1,$dst_w=-1,$dst_h=-1)
{
  if(!$file)
    return false;

  switch($type)
  {
    default:
    case 0:
      $tmp=imagecreatefrompng($file);
      break;
    case 1:
      $tmp=imagecreatefromjpeg($file);
      break;
    case 2:
      $tmp=imagecreatefromgif($file);
      break;
  }

  if(!$tmp)
    return false;

  $dst_w=$dst_w<0 ? $this->image_width : $dst_w;
  $dst_h=$dst_h<0 ? $this->image_height : $dst_h;
  $src_w=$src_w<0 ? imagesx($tmp) : $src_w;
  $src_h=$src_h<0 ? imagesy($tmp) : $src_h;

  if($copyresized)
    $ret=imagecopyresized($this->image,$tmp,$dst_x,$dst_y,$src_x,$src_y,$dst_w,$dst_h,$src_w,$src_h);
  else
    $ret=imagecopy($this->image,$tmp,$dst_x,$dst_y,$src_x,$src_y,$src_w,$src_h);

  imagedestroy($tmp);
  return $ret;

}



function image_set_style($pixels)
{
  if(!$pixels || gettype($pixels)!="array")
    return false;

  $this->style=imagesetstyle($this->image,$pixels);
  return $this->style;
}



function image_set_brush($file,$type=0)
{
  if(!$file)
    return false;

  switch($type)
  {
    default:
    case 0:
      $this->brush=imagecreatefrompng($file);
      break;
    case 1:
      $this->brush=imagecreatefromjpeg($file);
      break;
    case 2:
      $this->brush=imagecreatefromgif($file);
      break;
  }

  if(!$this->brush)
    return false;

  return imagesetbrush($this->image,$this->brush);
}



function set_drawing($isfilled=false,$tiled=false,$styled=false,$brushed=false)
{
  $this->isfilled=$isfilled;
  $this->tiled=$tiled;
  $this->styled=$styled;
  $this->brushed=$brushed;
}



function image_set_point($file=NULL,$type=0,$for_hgraph=false,$x=false,$y=false)
{
  if($file)
  {
    switch($type)
    {
      default:
      case 0:
        $this->point=imagecreatefrompng($file);
        break;
      case 1:
        $this->point=imagecreatefromjpeg($file);
        break;
      case 2:
        $this->point=imagecreatefromgif($file);
        break;
    }
  }

  if(!$this->point)
    return false;

  $this->point_width=imagesx($this->point);
  $this->point_height=imagesy($this->point);

  if($file)
  {
    $this->point_filename=$file;
    $this->point_filetype=$type;
  }

  if($for_hgraph)
  {
    $this->point_x=$x!==false ? $x : $x-$this->point_width/2;
    $this->point_y=$y!==false ? $y : $y+$this->point_height/2;
  }
  else
  {
    $this->point_x=$x!==false ? $x : $x-$this->point_width;
    $this->point_y=$y!==false ? $y : $y+$this->point_height;
  }

  return $this->point;
}



function image_destroy_point()
{
  if($this->point)
  {
    imagedestroy($this->point);
    $this->point=NULL;
    $this->point_filename='';
  }
}



function image_rotate_point($angle=0)
{
  if($this->point==NULL)
    return false;

  $tmp=imagerotate($this->point,$angle,$this->color);

  if(!$tmp)
    return false;

  imagedestroy($this->point);
  $this->point=$tmp;

  return true;
}



function image_make_color_transparent($closest=false)
{
  if($closest)
    $color=imagecolorclosest($this->image,$this->r,$this->g,$this->b);
  else
    $color=$this->color;

  return imagecolortransparent($this->image,$color);
}



function rgb($r=255,$g=255,$b=255,$transperency=0)
{
  if($r==0 && $g==0 && $b==0)
  {
    $r=1;
    $g=1;
    $b=1;
  }

  if(!$transperency)
    return imagecolorallocate($this->image,$r,$g,$b);
  else
    return imagecolorallocatealpha($this->image,$r,$g,$b,$transperency);
}



function to_unicode($text,$from='w')
{
  $text=convert_cyr_string($text,$from,'i');
  $uni='';

  for($i=0, $len=strlen($text); $i<$len; $i++)
  {
    $char=$text{$i};
    $code=ord($char);
    $uni.=($code>175) ? "&#".(1040+($code-176)).";" : $char;
  }

  return $uni;

}



function destroy_all()
{
  if(imagedestroy($this->image))
    $this->image=NULL;

  if($this->tile)
  {
    if(imagedestroy($this->tile))
      $this->tile=NULL;
  }

  if($this->brush)
  {
    if(imagedestroy($this->brush))
      $this->brush=NULL;
  }

  if($this->point)
  {
    if(imagedestroy($this->point))
      $this->point=NULL;
  }

  if($this->image || $this->tile || $this->brush || $this->point)
    return false;

  return true;
}




function sgraph_set_values($values=array())
{
  $this->sgraph_values=$values;
}

function sgraph_set_arrows($backarrow=true,$frontarrow=false,$arrowx=12,$arrowy=3)
{
  $this->sgraph_arrowx=$arrowx;
  $this->sgraph_arrowy=$arrowy;
  $this->sgraph_backarrow=$backarrow;
  $this->sgraph_frontarrow=$frontarrow;
}

function sgraph_set_maxheight($maxheight=150)
{
  $this->sgraph_maxheight=$maxheight;
}

function sgraph_set_center($x=0,$y=0)
{
  $this->sgraph_x=$x;
  $this->sgraph_y=$this->image_height-$y;
}

function sgraph_set_fill($transparency=NULL,$r=-1,$g=-1,$b=-1)
{
  $this->sgraph_transparency=$transparency;
  if($r<0 || $g<0 || $b<0)
  {
    $this->sgraph_r=$this->r;
    $this->sgraph_g=$this->g;
    $this->sgraph_b=$this->b;
  }
  else
  {
    $this->sgraph_r=$r;
    $this->sgraph_g=$g;
    $this->sgraph_b=$b;
  }
}



function make_sgraph()
{
  $oldx=$this->sgraph_x;

  $maxelem=$this->sgraph_values[0];
  $newpoints=array();
  $newy=0;
  $tmparr=array();

  for($i=0,$tmp=count($this->sgraph_values);$i<$tmp;$i+=2)
  {
    if($this->sgraph_values[$i]>$maxelem)
      $maxelem=$this->sgraph_values[$i];
  }

  if($maxelem==0)
    $maxelem=1;


  for($i=0,$tmp=count($this->sgraph_values);$i<$tmp;$i+=2)
  {
    $newy=$this->sgraph_y-round($this->sgraph_maxheight*($this->sgraph_values[$i]/$maxelem));
    $newpoints[]=$newy;
  }

  $tmparr[]=$oldx;
  $tmparr[]=$this->sgraph_y;
  $k=0;

  for($i=0,$tmp=count($this->sgraph_values);$i<$tmp;$i+=2)
  {
    $k=$i/2;

    $tmpb=$oldx+$this->sgraph_values[$i+1];

    $this->image_line($oldx,$newpoints[$k],$tmpb,$newpoints[$k]);


    if($this->sgraph_backarrow)
      $this->image_polygon(array($oldx,$newpoints[$k],$oldx+$this->sgraph_arrowx,$newpoints[$k]-$this->sgraph_arrowy,$oldx+$this->sgraph_arrowx,$newpoints[$k]+$this->sgraph_arrowy),3,null,true);


    $tmparr[]=$oldx;
    $tmparr[]=$newpoints[$k];
    $tmparr[]=$tmpb;
    $tmparr[]=$newpoints[$k];


    $oldx+=$this->sgraph_values[$i+1];

    if($this->sgraph_frontarrow)
      $this->image_polygon(array($oldx,$newpoints[$k],$oldx-$this->sgraph_arrowx,$newpoints[$k]-$this->sgraph_arrowy,$oldx-$this->sgraph_arrowx,$newpoints[$k]+$this->sgraph_arrowy),3,null,true);
  }

  $tmparr[]=$oldx;
  $tmparr[]=$this->sgraph_y;

  if($this->sgraph_transparency!=NULL)
  {
    $scolor=$this->rgb($this->sgraph_r,$this->sgraph_g,$this->sgraph_b,$this->sgraph_transparency);
    $this->image_polygon($tmparr,count($tmparr)/2,$scolor,true);
  }
}

}
?>